#if !defined(AFX_CESIMCASEGRAPHVIEW_H__F42A5C62_8AAE_4352_9F4C_003DBC17C891__INCLUDED_)
#define AFX_CESIMCASEGRAPHVIEW_H__F42A5C62_8AAE_4352_9F4C_003DBC17C891__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CESimCaseGraphView.h : header file
//

#include "TitleTip.h"

/////////////////////////////////////////////////////////////////////////////
// CCESimCaseGraphView view
class CCESimCaseGraphView : public CScrollView
{
public:
	CCESimCaseGraphView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CCESimCaseGraphView)

private:
	enum { RULER_THICK=13, RULER_CLR=RGB(236,233,216), RULER_SPAN=100, RULER_ARROW_HEIGHT=5, RULER_ARROW_WIDTH=5 };
	enum { TOOL_SELECT=32771, TOOL_CONDITION, TOOL_EVENT, TOOL_EDGE, TOOL_POLYGON, TOOL_LABEL, TOOL_TOKEN };
	enum {	CT_NONE,					// capture type NONE
			CT_DRAGGING_STEP,			// dragging step
			CT_DRAGGING_CASE,			// dragging case
			CT_DRAGGING_LBL,			// dragging label
			CT_DRAGGING_POLYGON,		// dragging entire polygon
			CT_DRAGGING_POLYGON_POINT,	// dragging one polygon point
			CT_DRAGGING_MULTI_SELECT,	// 
			CT_DRAWING_SELECT_RECT,		// 
			};
	enum { CASE_GRID_SPAN=60 };

	int		m_case_grid_size; // m_case_grid_size*m_case_grid_size=pocet mist, ve kterych muze byt case umisten


private:
	int			m_tool_selected;
	bool		m_mouse_capture;
	bool		m_mouse_moved;
	bool		m_highlight_reachable;
	CPoint		m_last_mouse_pt;
	CPoint		m_last_drag_pt;
	CPoint		m_first_mouse_pt; // for select rect
	int			m_capture_type;
	CPNElement*	m_hit_element; // dragging element
	CPNElement*	m_context_element; // 
	bool		m_ignore_move; // ignore mouse move when activating view
	bool		m_simulation_mode;
	bool		m_legend_written; // legenda je zobrazena
    CTitleTip	m_TitleTip;
	bool		m_export;
	CString		m_export_path;

	LOGFONT		m_ruler_logfont;
	CFont		m_ruler_font;
	CPoint		m_ruler_last_mouse_pt;
	bool		m_ruler_last_pt;

private:
	CPoint	SnapOnGrid(CPoint point);
	CPoint	GetRandomCasePosition();
	void	InvertLine(CDC* pDC,const CPoint& from,const CPoint& to);
	void	InvertRect(CDC* pDC,const CPoint& from,const CPoint& to);
	void	InvalidateRect(CRect rect,CDC* pDC=NULL);
	void	ShowRandomGraph();
	void	DrawRulerPos(CDC* pDC,CPoint& point,bool bClearOnly=false);

public:
	void SwitchedTo();

public:
	CCESimDoc*	GetDocument();

public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCESimCaseGraphView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnInitialUpdate();     // first time after construct
	virtual void OnUpdate(CView* pSender,LPARAM lHint,CObject* pHint);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll = TRUE);
	//}}AFX_VIRTUAL

protected:
	virtual ~CCESimCaseGraphView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CCESimCaseGraphView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnViewGrid();
	afx_msg void OnUpdateViewGrid(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags,CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnEditDelete();
	afx_msg void OnUpdateEditDelete(CCmdUI* pCmdUI);
	afx_msg void OnEdgeDeletepoint();
	afx_msg void OnUpdateEdgeDeletepoint(CCmdUI* pCmdUI);
	afx_msg void OnEdgeDeleteallpoints();
	afx_msg void OnUpdateEdgeDeleteallpoints(CCmdUI* pCmdUI);
	afx_msg void OnPolygonDeletepoint();
	afx_msg void OnUpdatePolygonDeletepoint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnalysisSmoothcasegraph(CCmdUI* pCmdUI);
	afx_msg void OnAnalysisSmoothcasegraph();
	afx_msg void OnViewPropertiesCasegraph();
	afx_msg void OnUpdateViewPropertiesCasegraph(CCmdUI* pCmdUI);
	afx_msg void OnEditPlacetofront();
	afx_msg void OnUpdateEditPlacetofront(CCmdUI* pCmdUI);
	afx_msg void OnEditPlacetoback();
	afx_msg void OnUpdateEditPlacetoback(CCmdUI* pCmdUI);
	afx_msg void OnCaseSetactualcase();
	afx_msg void OnUpdateCaseSetactualcase(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnCasegraphExporttoemf();
	afx_msg void OnCasegraphHighlightreachablecases();
	afx_msg void OnUpdateCasegraphHighlightreachablecases(CCmdUI* pCmdUI);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnViewRuler();
	afx_msg void OnUpdateViewRuler(CCmdUI* pCmdUI);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	afx_msg void OnToolChange(UINT nID);
	afx_msg void OnUpdateToolsChange(CCmdUI* pCmdUI);
	afx_msg LRESULT OnUpdateView(WPARAM wparam,LPARAM lparam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CCESimCaseGraphView.cpp
inline CCESimDoc* CCESimCaseGraphView::GetDocument()
   { return (CCESimDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CESIMCASEGRAPHVIEW_H__F42A5C62_8AAE_4352_9F4C_003DBC17C891__INCLUDED_)
